package usi.dbdp.tljttz.controller.util;

import java.util.List;
import usi.dbdp.tljttz.controller.util.Circle;
import usi.dbdp.tljttz.controller.util.Point2D;

public class IsPtInPoly {

   public static void main(String[] args) {
      Point2D point = new Point2D(117.8163D, 30.9495D);
      Point2D centerPoint = new Point2D(117.81605D, 30.949518D);
      Circle c = new Circle();
      c.setCC(centerPoint);
      c.setR(0.0012D);
      String s = distencePC(point, c);
      System.out.println("点是否在圆内：" + s);
   }

   public static boolean isPtInPoly(Point2D point, List pts) {
      int N = pts.size();
      boolean boundOrVertex = true;
      int intersectCount = 0;
      double precision = 2.0E-10D;
      Point2D p = point;
      Point2D p1 = (Point2D)pts.get(0);

      for(int i = 1; i <= N; ++i) {
         if(p.equals(p1)) {
            return boundOrVertex;
         }

         Point2D p2 = (Point2D)pts.get(i % N);
         if(p.x >= Math.min(p1.x, p2.x) && p.x <= Math.max(p1.x, p2.x)) {
            if(p.x > Math.min(p1.x, p2.x) && p.x < Math.max(p1.x, p2.x)) {
               if(p.y <= Math.max(p1.y, p2.y)) {
                  if(p1.x == p2.x && p.y >= Math.min(p1.y, p2.y)) {
                     return boundOrVertex;
                  }

                  if(p1.y == p2.y) {
                     if(p1.y == p.y) {
                        return boundOrVertex;
                     }

                     ++intersectCount;
                  } else {
                     double var13 = (p.x - p1.x) * (p2.y - p1.y) / (p2.x - p1.x) + p1.y;
                     if(Math.abs(p.y - var13) < precision) {
                        return boundOrVertex;
                     }

                     if(p.y < var13) {
                        ++intersectCount;
                     }
                  }
               }
            } else if(p.x == p2.x && p.y <= p2.y) {
               Point2D p3 = (Point2D)pts.get((i + 1) % N);
               if(p.x >= Math.min(p1.x, p3.x) && p.x <= Math.max(p1.x, p3.x)) {
                  ++intersectCount;
               } else {
                  intersectCount += 2;
               }
            }

            p1 = p2;
         } else {
            p1 = p2;
         }
      }

      return intersectCount % 2 != 0;
   }

   public static String distencePC(Point2D p, Circle c) {
      double d2 = Math.hypot(p.getX() - c.getCC().getX(), p.getY() - c.getCC().getY());
      System.out.println("d2==" + d2);
      System.out.println(d2);
      double r = c.getR();
      String s;
      if(d2 > r) {
         s = "*圆外*";
      } else if(d2 < r) {
         s = "圆内";
      } else {
         s = "圆上";
      }

      return s;
   }
}
